clear all;
% Initialize the LMI
% |A'X+XA XB C'|
% |  B'X  -I D'| <1
% |  C    D  -I|
% 
% X>0

% A,B,C,D - the state space representation of the closed loop system
% function lmisys = brlinit(A,B,C,D)
% 
% n = size(A);
% 
 setlmis([]);
% Aki0 = [0 1;0 0];
% Bki = [0;1];
loopno = 2;
for k = 1:loopno 
    [daki,kn,sdaki] = lmivar(1,[1 0]);
    [dAki,kn,sdAki] = lmivar(3,[0,0;0,-sdaki]);
    if k==1
        [dAk,kn,sdAk] = lmivar(3,[sdAki,zeros(2,2*(loopno-k))]);
%         Bk = [dBki zeros(2,loopno-k)];
    end
    if k~=1 && k~=loopno
        [dAk,kn,sdAk] = lmivar(3,[sdAk;zeros(2,(2*(k-1))),sdAki,zeros(2,2*(loopno-k))]);
%         Bk = [Bk; zeros(2,k-1) Bki zeros(2,loopno-k)];
    end
    if k==loopno
        [dAk,kn,sdAk] = lmivar(3,[sdAk;zeros(2,2*(loopno-1)),sdAki]);
%         Bk = [Bk;zeros(2,loopno-1) Bki];
    end
end


for k = 1:loopno 
    [dCki,kn,sdCki] = lmivar(2,[1 2]);
    if k==1
        [dCk,kn,sdCk] = lmivar(3,[sdCki,zeros(1,2*(loopno-k))]);
    end
    if k~=1 && k~=loopno
        [dCk,kn,sdCk] = lmivar(3,[sdCk;zeros(1,(2*(k-1))),sdCki,zeros(1,2*(loopno-k))]);
    end
    if k==loopno
      [dCk,kn,sdCk] = lmivar(3,[sdCk;zeros(1,2*(loopno-1)),sdCki]);
    end
end

for k = 1:loopno 
    [dDki,kn,sdDki] = lmivar(1,[1 0]);
    if k==1
        [dDk,kn,sdDk] = lmivar(3,[sdDki,zeros(1,loopno-k)]);
    end
    if k~=1 && k~=loopno
    [Dk,kn,sDk] = lmivar(3,[sdDk;zeros(1,k-1),sDki,zeros(1,loopno-k)]);
    end
    if k==loopno
      [dDk,kn,sdDk] = lmivar(3,[sdDk;zeros(1,loopno-1),sdDki]);
    end
end

[dX,kn,sdX] = lmivar(1,[length(Acl) 1]);

% 1st LMI
% BRL = newlmi; %LMI form the Bounded Real Lemma
% limterm([BRL 1 1 X],A',1); % A'X
% limterm([BRL 1 1 X],A,1);  % XA
% limterm([BRL 1 2 X],1,B);
% limterm([BRL 1 3 0],C');
% limterm([BRL 2 2 0],-1);
% limterm([BRL 2 3 0],D');
% limterm([BRL 3 3 0],-1);
% 
% % 2nd LMI
% Xpos = newlmi;
% lmiterm([-Xpos 1 1 X],1,1);
% 
% lmisys = getlmis;