% clear all
% A = [-1 -2 1;3 2 1;1 -2 -1];
% B = [1;0;1];
% Q = [1 -1 0; -1 -3 -12; 0 -12 -36];
% 
% 
% 
% setlmis([])
% [X kn sX] = lmivar(1,[3 1]);
% 
% lmiterm([1 1 1 X],1,A,'s')
% lmiterm([1 1 1 0],Q)
% lmiterm([1 1 2 X],1,B)
% lmiterm([1 2 2 0],-1) 
% % lmiterm([1 2 1 X],B',1)
% 
% 
% 
% LMIs = getlmis;
% 
% c = mat2dec(LMIs,eye(3));
% 
% % options = [1e-5,0,0,0,0];
% % [copt,xopt] = mincx(LMIs,c,options);
% [copt,xopt] = mincx(LMIs,c,[]);
% valX = dec2mat(LMIs,xopt,X)

setlmis([]);
[gamma,kn,sgamma] = lmivar(1,[1 0]);

subX0rowcol1Length = length(Ag);
subX0rowcol2Length = length(Ap);
subX0rowcol3Length = length(Ao);
subX0rowcol4Length = length(Ak);

loopno = 2;
for k = 1:loopno 
    [daki(k),kn(k),sdaki(k)] = lmivar(1,[1 0]);
    [dAki,kn,sdAki] = lmivar(3,[0,0;0,-sdaki(k)]);
    if k==1
        [dAk,kn,sdAk] = lmivar(3,[sdAki,zeros(2,2*(loopno-k))]);
%         Bk = [dBki zeros(2,loopno-k)];
    end
    if k~=1 && k~=loopno
        [dAk,kn,sdAk] = lmivar(3,[sdAk;zeros(2,(2*(k-1))),sdAki,zeros(2,2*(loopno-k))]);
%         Bk = [Bk; zeros(2,k-1) Bki zeros(2,loopno-k)];
    end
    if k==loopno
        [dAk,kn,sdAk] = lmivar(3,[sdAk;zeros(2,2*(loopno-1)),sdAki]);
%         Bk = [Bk;zeros(2,loopno-1) Bki];
    end
end
for k = 1:loopno 
    [dck1i(k),kn(k),sdck1i(k)] = lmivar(1,[1 0]);
    [dck2i(k),kn(k),sdck2i(k)] = lmivar(1,[1 0]);
    [dCki,kn,sdCki] = lmivar(3,[sdck1i(k),sdck2i(k)]);
    
    if k==1
        [dCk,kn,sdCk] = lmivar(3,[sdCki,zeros(1,2*(loopno-k))]);
    end
    if k~=1 && k~=loopno
        [dCk,kn,sdCk] = lmivar(3,[sdCk;zeros(1,(2*(k-1))),sdCki(k),zeros(1,2*(loopno-k))]);
    end
    if k==loopno
      [dCk,kn,sdCk] = lmivar(3,[sdCk;zeros(1,2*(loopno-1)),sdCki]);
    end
end

for k = 1:loopno 
    [dDki(k),kn(k),sdDki(k)] = lmivar(1,[1 0]);
    if k==1
        [dDk,kn,sdDk] = lmivar(3,[sdDki(k),zeros(1,loopno-k)]);
    end
    if k~=1 && k~=loopno
    [Dk,kn,sDk] = lmivar(3,[sdDk;zeros(1,k-1),sDki(k),zeros(1,loopno-k)]);
    end
    if k==loopno
      [dDk,kn,sdDk] = lmivar(3,[sdDk;zeros(1,loopno-1),sdDki(k)]);
    end
end


for k = 1:length(Acl)
    for i = k:length(Acl)
        [dX(k,i),kn,sdX(k,i)] =  lmivar(1,[1 0]);
    end
end
sdXT = sdX';

% dX11
for k = 1:subX0rowcol1Length
    if k==1
        [dX11,kn,sdX11] = lmivar(3,sdX(k,k:subX0rowcol1Length));   
    else
        [dX11,kn,sdX11] = lmivar(3,[sdX11;sdXT(k,1:k-1),sdX(k,k:subX0rowcol1Length)]);
    end
end

% dX12
for k = 1:subX0rowcol1Length
    if k==1
        [dX12,kn,sdX12] = lmivar(3,sdX(k,subX0rowcol1Length+1:subX0rowcol1Length+subX0rowcol2Length));   
    else
        [dX12,kn,sdX12] = lmivar(3,[sdX12;sdX(k,subX0rowcol1Length+1:subX0rowcol1Length+subX0rowcol2Length)]);
    end
end

% dX13
for k = 1:subX0rowcol1Length
    if k==1
        [dX13,kn,sdX13] = lmivar(3,sdX(k,subX0rowcol1Length+subX0rowcol2Length+1:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length));   
    else
        [dX13,kn,sdX13] = lmivar(3,[sdX13;sdX(k,subX0rowcol1Length+subX0rowcol2Length+1:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length)]);
    end
end

% dX14
for k = 1:subX0rowcol1Length
    if k==1
        [dX14,kn,sdX14] = lmivar(3,sdX(k,subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:length(Acl)));   
    else
        [dX14,kn,sdX14] = lmivar(3,[sdX14;sdX(k,subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:length(Acl))]);
    end
end

% dX21
[dX21,kn,sdX21] = lmivar(3,sdX12');

for k = subX0rowcol1Length+1:subX0rowcol1Length+subX0rowcol2Length 
    if k==subX0rowcol1Length+1
        [dX22,kn,sdX22] = lmivar(3,sdX(k,k:subX0rowcol1Length+subX0rowcol2Length));   
    else
        [dX22,kn,sdX22] = lmivar(3,[sdX22;sdXT(k,subX0rowcol1Length+1:k-1),sdX(k,k:subX0rowcol1Length+subX0rowcol2Length)]);
    end
end

% dX23
for k = subX0rowcol1Length+1:subX0rowcol1Length+subX0rowcol2Length 
    if k==subX0rowcol1Length+1
        [dX23,kn,sdX23] = lmivar(3,sdX(k,subX0rowcol1Length+subX0rowcol2Length+1:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length));   
    else
        [dX23,kn,sdX23] = lmivar(3,[sdX23;sdX(k,subX0rowcol1Length+subX0rowcol2Length+1:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length)]);
    end
end

% dX24
for k = subX0rowcol1Length+1:subX0rowcol1Length+subX0rowcol2Length 
    if k==subX0rowcol1Length+1
        [dX24,kn,sdX24] = lmivar(3,sdX(k,subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:length(Acl)));   
    else
        [dX24,kn,sdX24] = lmivar(3,[sdX24;sdX(k,subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:length(Acl))]);
    end
end
 
[dX31,kn,sdX31] = lmivar(3,sdX13');
[dX32,kn,sdX32] = lmivar(3,sdX23');

for k = subX0rowcol1Length+subX0rowcol2Length+1:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length
    if k==subX0rowcol1Length+subX0rowcol2Length+1
        [dX33,kn,sdX33] = lmivar(3,sdX(k,k:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length));   
    else
        [dX33,kn,sdX33] = lmivar(3,[sdX33;sdXT(k,subX0rowcol1Length+subX0rowcol2Length+1:k-1),sdX(k,k:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length)]);
    end
end

% dX34
for k = subX0rowcol1Length+subX0rowcol2Length+1:subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length
    if k==subX0rowcol1Length+subX0rowcol2Length+1
        [dX34,kn,sdX34] = lmivar(3,sdX(k,subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:length(Acl)));   
    else
        [dX34,kn,sdX34] = lmivar(3,[sdX34;sdX(k,subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:length(Acl))]);
    end
end

[dX41,kn,sdX41] = lmivar(3,sdX14');
[dX42,kn,sdX42] = lmivar(3,sdX24');
[dX43,kn,sdX43] = lmivar(3,sdX34');

for k = subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:length(Acl)
    if k==subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1
        [dX44,kn,sdX44] = lmivar(3,sdX(k,k:length(Acl)));   
    else
        [dX44,kn,sdX44] = lmivar(3,[sdX44;sdXT(k,subX0rowcol1Length+subX0rowcol2Length+subX0rowcol3Length+1:k-1),sdX(k,k:length(Acl))]);
    end
end

[dXtot,kn,sdXtot]= lmivar(3,[sdX11,sdX12,sdX13,sdX14;sdX21,sdX22,sdX23,sdX24;sdX31,sdX32,sdX33,sdX34;sdX41,sdX42,sdX43,sdX44]);












