% Plotting
close all

figure(1)
subplot(2,1,1)
plot(time,xD1,'b-.',time,less1_1,'b--',[30 30],[-0.5 1.5],'k-',time,above0_9,'k--');
% xlim([0 50]);
% ylim([-0.1 1.2]);
subplot(2,1,2)
plot(time,xB1,'r-.',time,less1_1,'r--',[30 30],[-0.2 1.2],'k-',time,above0_9,'k--');
% xlim([0 50]);
% ylim([-0.1 1.2]);
% print -dpng gfx/SIMCtunSingle


figure(2);
subplot(3,1,1)
plot(time,xD46,'b-.',time,xB46,'r-.',[30 30],[-0.1 1],'k-',time,above0_55,'r--',time,above0_35,'b-',time,less0_5,'b--',time,less0_7,'r--');
% legend('x_D','x_B','Location','Best')
title('Composition when [0.4 0.6] step')
ylabel('Composition')
xlabel('time [min]')
% ylim([-0.1 0.8]);

% subplot(2,2,3)
% plot(time,eD46,'b-.',time,eB46,'r--');
% legend('e_D','e_B','Location','Best')
% title('Reference error')
% ylabel('Error')
% xlabel('time [min]')
% 
% subplot(2,2,4)
% plot(time,ucontD46,'b-.',time,ucontB46,'r--');
% legend('u_1','u_2','Location','Best')
% title('Controller output')
% xlabel('time [min]')


% figure(4);
subplot(3,1,2)
plot(time,xD10,'b-.',time,xB10,'r-.',time,less1_1,'b--',[30 30],[-0.5 1.5],'k-',time,above0_9,'b--',time,less0_5,'r--');
% legend('Dx_D','x_B','Location','Best')
title('Composition when [1 0] step')
ylabel('Composition')
xlabel('time [min]')
% ylim([-0.5 1.3]);

% subplot(2,2,3)
% plot(time,eD10,'b-.',time,eB10,'r--');
% legend('e_D','e_B','Location','Best')
% title('Reference error')
% ylabel('Error')
% xlabel('time [min]')
% 
% subplot(2,2,4)
% plot(time,ucontD10,'b-.',time,ucontB10,'r--');
% legend('u_1','u_2','Location','Best')
% title('Controller output')
% xlabel('time [min]')


% figure(5);
subplot(3,1,3)
plot(time,xD01,'b-.',time,xB01,'r-.',time,less1_1,'r--',[30 30],[-0.2 1.2],'k--',time,above0_9,'r--',time,less0_5,'b--');
legend('Dx_D','x_B','Location','SouthEast')
title('Composition when [0 1] step')
ylabel('Composition')
xlabel('time [min]')
% ylim([-0.5 1.3]);

% subplot(2,2,3)
% plot(time,eD01,'b-.',time,eB01,'r--');
% legend('e_D','e_B','Location','Best')
% title('Reference error')
% ylabel('Composition')
% xlabel('time [min]')
% 
% subplot(2,2,4)
% plot(time,ucontD01,'b-.',time,ucontB01,'r--');
% legend('u_1','u_2','Location','Best')
% title('Controller output')
% xlabel('time [min]')
% print -dpng gfx/SIMCtunWhole
