close all
% File Begins
clear less1_1
clear above0_9
clear less0_5
clear above0_35 
clear less0_7 
clear above0_55

simtime = 500;
[tsim xsim ysim] = sim('Individual_SIMC_tun',simtime);
time = output.time;

% Spesifications
% [1 0] and [0 1]
less1_1 = 1.1*ones(1,length(time));
above0_9 = 0.9*ones(1,length(time));
less0_5 = 0.5*ones(1,length(time));
% [0.4 0.6]
above0_35 = 0.35*ones(1,length(time));
less0_7 = 0.7*ones(1,length(time));
above0_55 = 0.55*ones(1,length(time));
% !!Stationary requirements are not included!!!

% Values from simulation
% Single loop values
xD1 = outputInd1.signals.values(:,1);
uD1 = contOut1.signals.values(:,1);
xB1 = outputInd2.signals.values(:,1);
uB1 = contOut2.signals.values(:,1);

% Multiloop values
% step in [1 0]
xD10 = output.signals.values(:,1);
xB10 = output.signals.values(:,2);
eD10 = e.signals.values(:,1);
eB10 = e.signals.values(:,2);
ucontD10 = controllerOut.signals.values(:,1);
ucontB10 = controllerOut.signals.values(:,2);
uD10 = systemIn.signals.values(:,1);
uB10 = systemIn.signals.values(:,2);
% step in [1 0]
xD01 = output1.signals.values(:,1);
xB01 = output1.signals.values(:,2);
eD01 = e1.signals.values(:,1);
eB01 = e1.signals.values(:,2);
ucontD01 = controllerOut1.signals.values(:,1);
ucontB01 = controllerOut1.signals.values(:,2);
uD01 = systemIn1.signals.values(:,1);
uB01 = systemIn1.signals.values(:,2);
% step in [0.4 0.6]
xD46 = output2.signals.values(:,1);
xB46 = output2.signals.values(:,2);
eD46 = e2.signals.values(:,1);
eB46 = e2.signals.values(:,2);
ucontD46 = controllerOut2.signals.values(:,1);
ucontB46 = controllerOut2.signals.values(:,2);
uD46 = systemIn2.signals.values(:,1);
uB46 = systemIn2.signals.values(:,2);

SIMCplottingInd;