contrMatrixinit;

%%  Makin system matrces of transfer functions
Gss = ss(G,'min');
Woss = ss(Wo,'min');
Wpss = ss(Wp,'min');
KPIDss = ss(KPID,'min');

Agsize = size(Gss.a);
Apsize = size(Wpss.a);
Aosize = size(Woss.a);
WpbGcsize = size(-Wpss.b*Gss.c);
WobGcsize = size(Woss.b*Gss.c);
Wpbsize = size(Wpss.b);
Wpcsize = size(Wpss.c);
Wocsize = size(Woss.c);
WodGcsize = size(Woss.d*Gss.c);

Ag = Gss.a;
Bg = Gss.b;
Cg = Gss.c;
Dg = Gss.d;

Ao = Woss.a;
Bo = Woss.b;
Co = Woss.c;
Do = Woss.d;

Ap = Wpss.a;
Bp = Wpss.b;
Cp = Wpss.c;
Dp = Wpss.d;

%% Making the P matrix for comparasition 
systemnames = 'Gss Woss Wpss';
inputvar = '[w(2); u(2)]';
outputvar = '[Wpss; Woss;w-Gss]';
input_to_Gss = '[u]';
input_to_Wpss = '[-Gss+w]';
input_to_Woss = '[Gss]';
sysoutname = 'P';
sysic;

%%
A = [Ag zeros(Agsize(1),Apsize(2)) zeros(Agsize(1),Aosize(2));
     -Bp*Cg Ap zeros(WpbGcsize(1),Aosize(2));
     Bo*Cg zeros(WobGcsize(1),Apsize(2)) Ao];

B1 = [zeros(Agsize(1),Wpbsize(2));Bp;zeros(Aosize(1),Wpbsize(2))];
B2 = [Bg;-Bp*Dg;Bo*Dg];

C1u = [zeros(WodGcsize(1),WodGcsize(2)) zeros(Wpcsize(1),Wpcsize(2)) zeros(Wocsize(1),Wocsize(2));
       Do*Cg zeros(Wpcsize(1),Wpcsize(2)) Co];

C2 = [-Cg zeros(2,length(A)-length(Gss.c))];
gammaD11 = [Dp; zeros(WodGcsize(1),length(Wpss.d))];

gammaC1 = [-Dp*Cg Cp zeros(Wocsize(1),Wocsize(2));
           zeros(WodGcsize(1),WodGcsize(2)) zeros(Wpcsize(1),Wpcsize(2)) zeros(Wocsize(1),Wocsize(2))];

Acl = [A+B2*Dk*C2 B2*Ck;
       Bk*C2 Ak];

Bcl = [B1+B2*Dk;
       Bk];

C1usize=size(C1u);
Cclu = [C1u zeros(C1usize(1),length(Ak))];
Cclgamma = [gammaC1 zeros(C1usize(1),length(Ak))];
Dclgamma =gammaD11;
Dcl = Dclgamma;
Ccl = Cclu+Cclgamma;





